#!/usr/local/bin/perl
####################################################################
#
# news_new_add.pl
#
# Adds a record to news.txt file
#
# by Niv
# Last modified 23/10/2003
####################################################################

# The name of the database file
    $filename = "news.txt";



#========================================
# Construct Date String
#========================================

# Gets the data from the form
    &parse_form;
        $title = $FORM{'title'};
        $description = $FORM{'description'};
        $date = $FORM{'date'};
        $do = $FORM{'do'};

######### START SUBMIT ###########
if ($do eq "Submit"){       
# Redirection after update

    $redir="news_manage.pl";

    if ($date eq "")
    {
        # Format date
        @days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
	@months = ('January','Feburary','March','April','May','June','July','August','September',
	            'October','November','December');
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = gmtime(time);
	    if($hour < 10) { $hour = "0$hour"; }
	    if ($min < 10) { $min = "0$min"; }
	    if ($sec < 10) { $sec = "0$sec"; }
	        $saveyear = ($year % 100);
	    $year = 1900 + $year;
	
    $date = "$days[$wday], $months[$mon] $mday, $year";
        $date_created = $date;        
    }
    
# Calls subroutine to validate the input
  &validate1;

# Removes ^ that might be present

        $title =~ s/\|//g;
        $description =~ s/\|//g;

# Switch 'end of line' with '^' sign
        $description =~ s/\n/\^/g;

# Removes | that might be present

        $title =~ s/\|//g;
        $description =~ s/\|//g;
  
# Removes " that might be present

#        $title =~ s/\"//g;

# Reads existing records 
  open (FILE,"$filename") || die "Can not open $filename while trying to add new record!\n";
  @LINES=<FILE>;
  close(FILE);

# Create record ID
    srand;
    $id = int(rand 100000);
    $id = $id . time;
  
  $newrec = $id . "|" . $date_created . "|" . $title . "|" . $description . "|" . "\n";

# Adds the new record to the top of the database
  unshift (@LINES, $newrec);

# Write the updated database to file
  if (open (FILE,">$filename"))
  { print FILE @LINES;
    close(FILE);
  }
  else
  {
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head>\n";
    print "<title>Error!</title>\n";
    print "</head>\n";
    print "<body>\n";
    print "<h1>";
    print "Failed to write new entry to database file: $filename.";
    print "</h1><br>";
    print "</body></html>";
    exit;
   }
   
# Redirects to selected page

print "Location: $redir\n\n";
}
######### END OF SUBMIT ##########
######### START PREVIEW ########## a copy of news_preview.htm
else
{

# Format date
    $date=scalar(localtime);
    @dateparts = split(/ /,$date);
    $d = $dateparts[1] . " ";
    $m = $dateparts[2] . ", ";
    $y = $dateparts[4];
    $date_created = $d . $m . $y;  
    $date = $date_created;
 
# Calls subroutine to validate the input
  &validate2;

  $description1=$description;
# Remove 'end of line' so there are no double spaces
  $description =~ s/\n//g;
# Switch 'end of line' with <br> for the preview display
  $description1 =~ s/\n/<br>/g;

print qq~


<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<title>BLOG MANAGER</title>


<style type="text/css">

input.button {
    color : #000000;
    background-color : #EFEFEF;
    font: normal 12px Arial, Helvetica, Verdana, sans-serif;
    border-color : #000000;
    }    

input.formbutton {
    color : #000000;
    font: normal 12px Arial, Helvetica, Verdana, sans-serif;
    border-color : #000000;
    }    
    
</style>


<script language="javascript">
<!-- // will be used for description textarea
function store(ftext) {
   if (ftext.createTextRange) {
        ftext.caretPos = document.selection.createRange().duplicate();
   }
}

function AddText(Msg) 
{
   if (document.formname.description.createTextRange && document.formname.description.caretPos) {
        var caretPos = document.formname.description.caretPos;
        caretPos.text = Msg;
   } else {
        document.formname.description.value+=Msg;
   }
   document.formname.description.focus();
}

function getText() {
   if (document.formname.description.createTextRange && document.formname.description.caretPos) {
        return document.formname.description.caretPos.text;
   } else {
        return '';
   }
}

function addupdate(t)
  {
     AddText(t);
  }

//-->
</script>


<script language="javascript">
<!-- // will be used for title textarea
function title_store(ftext) {
   if (ftext.createTextRange) {
        ftext.caretPos = document.selection.createRange().duplicate();
   }
}

function title_AddText(Msg) 
{
   if (document.formname.title.createTextRange && document.formname.title.caretPos) {
        var caretPos = document.formname.title.caretPos;
        caretPos.text = Msg;
   } else {
        document.formname.title.value+=Msg;
   }
   document.formname.title.focus();
}

function title_getText() {
   if (document.formname.title.createTextRange && document.formname.title.caretPos) {
        return document.formname.title.caretPos.text;
   } else {
        return '';
   }
}

function title_addupdate(t)
  {
     title_AddText(t);
  }

//-->
</script>


</head>

<body bgcolor="#F3F3F3">
<form name="formname" method="POST" action="news_new_add.pl">

<div align="center">
  <center>
  <table border="0" cellpadding="0" cellspacing="0" width="500" bgcolor="#2C2C2C">
    <tr>
      <td width="100%">
        <div align="center">
          <table border="0" cellpadding="3" cellspacing="1" width="100%">
            <tr>
              <td width="100%" bgcolor="#C6D3EA">

<p align="center" style="word-spacing: 0; margin-top: 0; margin-bottom: 0"><b><font size="5">NEWS
FLASH MANAGER</font></b></p>
                <p align="center" style="word-spacing: 0; margin-top: 0; margin-bottom: 0"><b><font size="3">PREVIEW
                ENTRY</font></b></td>
            </tr>
          </table>
        </div>
      </td>
    </tr>
  </table>
  </center>
</div>

<p align="center" style="word-spacing: 0; margin-top: 0; margin-bottom: 0">&nbsp;
<div align="left">
  <table border="0" cellpadding="0" cellspacing="0" width="725">
    <tr>
      <td>
        <p style="word-spacing: 0; margin-top: 0; margin-bottom: 0" align="left"><a href="news_manage.pl"><font color="#000080" face="Courier New" size="2">Manage
        Entries</font></a><font color="#000080" face="Courier New" size="2"> <font face="Courier New" size="2"><a href="news_new.htm"><font color="#000080">Add
        a New Entry</font></a></font></font></td>
    </tr>
  </table>
</div>
<p style="word-spacing: 0; margin-top: 0; margin-bottom: 0">&nbsp;
<p style="word-spacing: 0; margin-top: 0; margin-bottom: 0">&nbsp;
<div align="center">
  <center>
  <table border="0" cellpadding="0" cellspacing="0" width="70%">
    <tr>
      <td width="100%">
        <hr align="left" width="90%" size="1">
      </td>
    </tr>
    <tr>
      <td width="100%"><b><span style="background-color: #C6D3EA">$title</span></b></td>
    </tr>
    <tr>
      <td width="100%">
        <p style="word-spacing: 0; margin-top: 0; margin-bottom: 0"><font face="Courier New" size="2">$date</font></p>
        <p style="word-spacing: 0; margin-top: 0; margin-bottom: 0">&nbsp;</td>
    </tr>
    <tr>
      <td width="100%"><font face="Arial">$description1</font></td>
    </tr>
    <tr>
      <td width="100%">
        <hr align="left" width="90%" size="1">
      </td>
    </tr>
  </table>
  </center>
</div>
<p style="word-spacing: 0; margin-top: 0; margin-bottom: 0">&nbsp;
<p style="word-spacing: 0; margin-top: 0; margin-bottom: 0">&nbsp;
<p style="word-spacing: 0; margin-top: 0; margin-bottom: 0">&nbsp;
<div align="left">
  <table border="0" cellpadding="2" width="601">
    <tr>
      <td nowrap width="162" valign="top"><b><font size="2" face="Arial">Title</font></b></td>
      <td nowrap width="421" valign="top">
            <p><input type="text" name="title" size="50" value="$title" onselect="title_store(this);" onclick="title_store(this);" onkeyup="title_store(this);" onchange="title_store(this);"></p>
      </td>
    </tr>
    <tr>
      <td nowrap width="162" valign="top"><font face="Courier New" size="2"><b>Insert
        HTML tags</b></font></td>
      <td nowrap width="421" valign="top"> 
        <input type="button" class="button" value="Image" name="image" onclick="javascript:title_addupdate('<br><img border=1 src=http://></br>');">&nbsp;
        <input type="button" class="button" value="Link" name="link" onclick="javascript:title_addupdate('<a href=http://>description</a>');">&nbsp;
        <input type="button" class="button" value="Italic" name="italic" onclick="javascript:title_addupdate('<i>text</i>');" style="font-style: italic">&nbsp;
        <input type="button" class="button" value="Bold" name="bold" onclick="javascript:title_addupdate('<b>text</b>');" style="font-weight: bold">&nbsp;
        <input type="button" class="button" value="Underline" name="underline" onclick="javascript:title_addupdate('<u>text</u>');" style="text-decoration: underline"></td>
    </tr>
    <tr>
      <td nowrap width="162" valign="top"></td>
      <td nowrap width="421" valign="top">
          <hr align="left" size="1">
      </td>
    </tr>
    <tr>
      <td nowrap width="162" valign="top"></td>
      <td nowrap width="421" valign="top">
      </td>
    </tr>
    <tr>
      <td nowrap width="162" valign="top"><b><font size="2" face="Arial">Description</font></b></td>
      <td nowrap width="421" valign="top"><textarea name=description COLS=70 ROWS=10 onselect="store(this);" onclick="store(this);" onkeyup="store(this);" onchange="store(this);" >$description</textarea></td>
    </tr>
    <tr>
      <td nowrap width="162" valign="top"><font face="Courier New" size="2"><b>Insert
        HTML tags</b></font></td>
      <td nowrap width="421" valign="top"> 
        <input type="button" class="button" value="Image" name="image" onclick="javascript:addupdate('<br><img border=1 src=http://></br>');">&nbsp;
        <input type="button" class="button" value="Link" name="link" onclick="javascript:addupdate('<a href=http://>description</a>');">&nbsp;
        <input type="button" class="button" value="Italic" name="italic" onclick="javascript:addupdate('<i>text</i>');" style="font-style: italic">&nbsp;
        <input type="button" class="button" value="Bold" name="bold" onclick="javascript:addupdate('<b>text</b>');" style="font-weight: bold">&nbsp;
        <input type="button" class="button" value="Underline" name="underline" onclick="javascript:addupdate('<u>text</u>');" style="text-decoration: underline"></td>
    </tr>
  </table>
</div>



<p><input type="submit" class="formbutton" value="Submit" name="do">&nbsp;&nbsp;&nbsp;&nbsp; <input type="reset" class="formbutton" value="Reset" name="B2">&nbsp;&nbsp;&nbsp;&nbsp;
<input type="submit" class="formbutton" value="Preview" name="do">&nbsp;&nbsp;&nbsp;&nbsp;
</form>





</body>

</html>



~;



}

##### END PREVIEW ##########

exit;

sub validate1 {

$errors="";

  if($title eq "")  {
    $errors=$errors . "Title is mandatory!\\n";
                    }
  if($description eq "")  {
    $errors=$errors . "Description is mandatory!\\n";
                    }


  if ($errors ne "")    {
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head>\n";
    print "<title>Error!</title>\n";
    print "</head>\n";
    print "<body>\n";
    print "<script language=\"JavaScript\">\n";
    print "{\n";
    print "alert(\"$errors\");\n";
    print "history.back();\n";
    print "}\n";
    print "</script>\n";
    print "</body></html>";
    exit;                
                            }
}

sub validate2 {

$errors="";

  if($title eq "")  {
    $errors=$errors . "Title is mandatory!\\n";
                    }
  if($description eq "")  {
    $errors=$errors . "Description is mandatory!\\n";
                    }


  if ($errors ne "")    {
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head>\n";
    print "<title>Error!</title>\n";
    print "</head>\n";
    print "<body>\n";
    print "<script language=\"JavaScript\">\n";
    print "{\n";
    print "alert(\"$errors\");\n";
    print "history.back();\n";
    print "}\n";
    print "</script>\n";
    print "</body></html>";
    exit;                
                            }
}




sub parse_form {

   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   if (length($buffer) < 5) {
         $buffer = $ENV{QUERY_STRING};
    }
 
  @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $FORM{$name} = $value;
   }
}